'              ********************************************

'              *              QMouse.BAS                  *

'              *  Mouse Routine for MS-QBasic/IBM-QBasic  *

'              *                1 9 9 5                   *

'              ********************************************



'                    Robert Wolf TV & Radio Service



'********************************* INI *************************************



    DEFINT A-Z

    DECLARE SUB Mouse (cx, dx, bx)

    DECLARE SUB MousePointer (SW)

    DIM SHARED a(9)                 'Set up array for code

                                                           

    DEF SEG = VARSEG(a(0))          'Get array segment (nnnn:    )

                                    '    (two 8 bit)

    FOR i = 0 TO 17                 'length of DATA to

       READ r                       'read

       POKE VARPTR(a(0)) + i, r     'into array/2 (nnnn:iiii) (one 8 bit)

    NEXT i                          'until 17



'**************************** Machine Code *********************************



DATA &HB8,&H00,&H00   :   ' mov  AX,[n]       [Swap code-(L),(H)] in AX

DATA &H55             :   ' push BP           Save BP

DATA &H8B,&HEC        :   ' mov  BP,SP        Get BP to c Seg

DATA &HCD,&H33        :   ' int  33           Interrupt 33

DATA &H92             :   ' xchg AX,[reg]     [Swap code-reg] in AX

DATA &H8B,&H5E,&H06   :   ' mov  BX,[BP+6]    Point to (variable)

DATA &H89,&H07        :   ' mov  [BX],AX      Put AX in (variable)

DATA &H5D             :   ' pop  BP           Restore BP

DATA &HCA,&H02,&H00   :   ' ret  2            Far return



'*********************** P R O G R A M   S C R E E N ***********************



     CLS



COLOR 14, 0

PRINT "                   Ŀ                 "

PRINT "                      Q b a s i c     M o u s e                    "

PRINT "                                    "

COLOR 4, 0

PRINT "      "

COLOR 10, 0

PRINT "                                                                   [End]           "

LOCATE 6, 4

COLOR 15, 1



'****************************** Mouse set up ******************************

           

                CALL MousePointer(0)      'Reset mouse and

                CALL MousePointer(1)      'turn pointer on

                CALL MousePointer(3)      'Get coordinates



'****************************** P R O G R A M ******************************



    DO WHILE k$ <> CHR$(27)

          k$ = INKEY$



        CALL Mouse(cx, dx, bx)



           LOCATE 22, 60

           PRINT cx                          'Display Row

           LOCATE 22, 66

           PRINT dx

             

              IF bx = 1 THEN                 'Filter a 1 for Left

                bx$ = "[ L e f t "           'Set or skip bx$

               ELSEIF bx = 2 THEN            'Filter a 2 for Right

                bx$ = "[ R i g h t"          'Set or skip bx$

               ELSE

                bx$ = "[           ]"        'Blank for No Button Event

               END IF

           LOCATE 22, 5

           PRINT bx$                          'Display Button Event

          

           IF bx = 1 THEN                      'If Left Button Click's

             IF cx = 4 THEN

               IF dx > 67 AND dx < 71 THEN     'on [ESC] Then

                 GOTO done                     'End Program

                 END IF

              END IF

            END IF

    LOOP



'******************************** Exit *************************************

done:

                 CALL MousePointer(2)              'Turn mouse off

   

    LOCATE 22, 1

    PRINT "                        " + CHR$(177) + "     G O O D      B Y E       " + CHR$(177) + "                        "

COLOR 7, 0

    DEF SEG

   

END

'**************************** Return to Basic ******************************



SUB Mouse (cx, dx, bx)

         

           POKE VARPTR(a(4)), &H92           'Swap code,Get CX setup

          CALL absolute(cx, VARPTR(a(0)))     'Run Code

              cx = cx / 8                     'Adjust 25x80

           POKE VARPTR(a(4)), &H91           'Swap code,Get DX setup

          CALL absolute(dx, VARPTR(a(0)))     'Run Code

              dx = dx / 8                     'Adjust 25x80

           POKE VARPTR(a(4)), &H93           'Swap code,Get BX setup

          CALL absolute(bx, VARPTR(a(0)))     'Run Code



                                   'Note :

                                   'Remove the /8

                                   'for graphics modes.



END SUB



SUB MousePointer (SW)

         

           POKE VARPTR(a(0)) + 1, SW         'Swap code,Set AX = (SW)

          CALL absolute(c, VARPTR(a(0)))     'Run Code



                                          'Note:

                                             'SW = 0-reset

                                             'SW = 1-on

                                             'SW = 2-off

                                             'SW = 3-coordinates





END SUB



